/*******************************************************************************
** INTEL CONFIDENTIAL
**
** Copyright (c) 2020-2023 Intel Corporation All Rights Reserved
**
** This software and the related documents are Intel copyrighted materials,
** and your use of them is governed by the express license under which they
** were provided to you ("License"). Unless the License provides otherwise,
** you may not use, modify, copy, publish, distribute, disclose or transmit
** this software or the related documents without Intel's prior written
** permission.
**
** The source code contained or described herein and all documents related to
** the source code ("Material") are owned by Intel Corporation or its suppliers
** or licensors.
**
** This software and the related documents are provided as is,
** with no express or implied warranties, other than those that are expressly
** stated in the License.
**
*******************************************************************************/

#pragma once

#include <map>
#include <memory>
#include <string>

#include "IpfProvider.h"

namespace Ipf
{
class SampleBatteryProvider : public ProviderDelegate
{
public:
	explicit SampleBatteryProvider(IFramework* pfw, const std::string& config = "{}");
	~SampleBatteryProvider();

protected:
	virtual void UpdateNamespace(const std::string&);
	virtual std::string ExecuteCommand(const std::string&, const std::string&);
	virtual void SetValue(const std::string&, const std::string&);
	virtual void SetValue(const std::string& path, bool value);
	virtual void RegisterEvent(const std::string& path);
	virtual void UnregisterEvent(const std::string& path);
};
} // namespace Ipf
